// Reversed tac
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LINE_LEN 256

struct line {
	struct line *next;
	char content[MAX_LINE_LEN];
};

struct line *readLinesReversed(FILE *f)
{
	struct line *list, *element;
	// temporary buffer to read to, so we
	// don't create a new list element on EOF
	char tempBuf[MAX_LINE_LEN];

	while (fgets(tempBuf, MAX_LINE_LEN, f) != 0) {
		element = malloc(sizeof(struct line));
		strncpy(element->content, tempBuf, MAX_LINE_LEN);
		element->next = list;
		list = element;
	}
	return list;
}

int main()
{
	struct line *lines;
	printf("Press CTRL+D to finish your input.\n");
	lines = readLinesReversed(stdin);
	while (lines) {
		printf("%s", lines->content);
		lines = lines->next;
	}
}

